import enum
"""
Network scan method types
"""
SCAN_METHOD_IP_RANGE = "ip_range"
SCAN_METHOD_IP_LIST = "ip_list"
SCAN_METHOD_SEED_ROUTER = "seed_router"

RPC_API_VERSION = "1.0"


class ScanMethod(enum.Enum):
    ip_list = 1
    ip_range = 2
    seed_router = 3


class ExecutionStatus(enum.Enum):
    canceled = 1
    completed = 2
    error = 3
    running = 4
    interrupted = 5


class ScheduleStatus(enum.Enum):
    unscheduled = 1
    scheduled = 2
    dismissed = 3


class DeviceStatus(enum.Enum):
    unknown = 1
    monitored = 2
    unmonitored = 3


class SnmpVersion(enum.Enum):
    v1 = 1
    v2c = 2
    v3 = 3


class SnmpAuthProtocol(enum.Enum):
    SHA = "SHA"
    MD5 = "MD5"


class SnmpPrivProtocol(enum.Enum):
    AES = "AES"
    DES3 = "3DES"
