import sqlalchemy as sa

from magellan.db.sqlalchemy.types import GUID

meta = sa.MetaData()

exclusion_lists = sa.Table(
    "exclusion_lists", meta,
    sa.Column("id", GUID, nullable=False, primary_key=True),
    sa.Column("name", sa.String(255), nullable=False),
    sa.Column("description", sa.String(1023), nullable=False),
    sa.Column("created_at", sa.DateTime),
    sa.Column("updated_at", sa.DateTime),
    mysql_engine="InnoDB",
    mysql_charset="utf8"
)

exclusion_list_items = sa.Table(
    "exclusion_list_items", meta,
    sa.Column("id", GUID, nullable=False, primary_key=True),
    sa.Column(
        "exclusion_list_id",
        GUID,
        sa.ForeignKey("exclusion_lists.id", ondelete="CASCADE"),
        nullable=False,
    ),
    sa.Column("address", sa.String(255), nullable=False),
    sa.Column("comment", sa.String(1023), nullable=True),
    sa.Column("created_at", sa.DateTime),
    sa.Column("updated_at", sa.DateTime),
    mysql_charset="utf8",
    mysql_engine="InnoDB"
)


def upgrade(migrate_engine):
    meta.bind = migrate_engine
    exclusion_lists.create()
    exclusion_list_items.create()


def downgrade(migrate_engine):
    meta.bind = migrate_engine
    exclusion_list_items.drop()
    exclusion_lists.drop()
