# -*- coding: utf-8 -*-

from abc import ABC, abstractmethod


class CrawlBackendInterface(ABC):
    @abstractmethod
    def neighbours(self, address):
        """
        Takes an IPv4Address and returns a set of IPv4Addresses that are
        neighbouring the targeted address

        Throws RuntimeError, AssertionError
        """


class InfoBackendInterface(ABC):
    @abstractmethod
    def info(self, address):
        """
        Takes an IPv4Address and returns a dict with additional information
        about the targeted address.

        Throws RuntimeError, AssertionError
        """


class ScanBackendInterface(ABC):
    @abstractmethod
    def scan(self, ip_range):
        """
        Takes an IPv4 range or subnet and return a list of live devices
        """
