# -*- coding: utf-8 -*-

from ipaddress import IPv4Address
from socket import gethostbyaddr, gethostbyname

from pyautodiscover.backend import InfoBackendInterface


class DNSBackend(InfoBackendInterface):
    def info(self, address):
        assert isinstance(address, IPv4Address)
        try:
            hostname, _, _ = gethostbyaddr(str(address))
            return {"sysName": hostname}
        except OSError as e:
            raise RuntimeError(str(e))

    @staticmethod
    def get_host_address_by_name(hostname):
        return gethostbyname(hostname)
